/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2016 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : CodeGenerator for RL78/G14 V2.04.04.03 [19 Aug 2016]
* Device(s)    : R5F104LE
* Tool-Chain   : CCRL
* Description  : This file implements main function.
* Creation Date: 2017/06/03
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_serial.h"
/* Start user code for include. Do not edit comment generated here */
#include <stddef.h>
#include <stdbool.h>
#include <stdlib.h>
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

#include "comdef.h"
#include "OLED_SSD1306.h"
#include "misakiUTF16.h"
#include "misakiUTF16FontData.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
#define I2C_LED_ADDR	(SSD1306_ADDR << 1)
#define I2C_RTC_ADDR	(0x68 << 1)
#define I2C_EEPROM_ADDR	(0x50 << 1)
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
int i2c_flag = 0;

static uint8_t g_y;
static uint8_t g_x;

static void RTC_DS1307_init(void);
static void RTC_DS1307_read(uint8_t *date);

static void OLED_SSD1306_init(void);
static void OLED_SSD1306_clear(void);
static char* OLED_SSD1306_writeChar(char *data);
static void OLED_SSD1306_newLine(void);
static void OLED_SSD1306_println(char *data);

MD_STATUS R_IICA0_Master_RestartRx(uint8_t, uint8_t * const, uint16_t, uint8_t);
/* End user code. Do not edit comment generated here */
void R_MAIN_UserInit(void);

/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
int main(void)
{
	uint8_t buf[7];
	uint8_t data[2];
	uint8_t last = 0xFF;
	char *week[] = {"日","月","火","水","木","金","土"};
	
    R_MAIN_UserInit();
    /* Start user code. Do not edit comment generated here */
	OLED_SSD1306_init();
	OLED_SSD1306_clear();
	RTC_DS1307_init();
	
	buf[0] = 0xFF;
	while (1U)
	{
		RTC_DS1307_read(buf);
		if(buf[0] != last) {
			g_y = 0;
			g_x = 0;
			last = buf[0];
			data[1] = 0;
			/* 年 */
			OLED_SSD1306_println("20");
			data[0] = (buf[6] >> 4) + 0x30;
			OLED_SSD1306_println(data);
			data[0] = (buf[6] & 0x0F) + 0x30;
			OLED_SSD1306_println(data);
			OLED_SSD1306_println("/");
			/* 月 */
			data[0] = (buf[5] >> 4) + 0x30;
			OLED_SSD1306_println(data);
			data[0] = (buf[5] & 0x0F) + 0x30;
			OLED_SSD1306_println(data);
			OLED_SSD1306_println("/");
			/* 日 */
			data[0] = (buf[4] >> 4) + 0x30;
			OLED_SSD1306_println(data);
			data[0] = (buf[4] & 0x0F) + 0x30;
			OLED_SSD1306_println(data);
			/* 曜日 */
			OLED_SSD1306_println("(");
			OLED_SSD1306_println(week[buf[3]]);
			OLED_SSD1306_println(")\n");
			/* 時 */
			data[0] = ((buf[2] >> 4) & 0x03) + 0x30;
			OLED_SSD1306_println(data);
			data[0] = (buf[2] & 0x0F) + 0x30;
			OLED_SSD1306_println(data);
			OLED_SSD1306_println(":");
			/* 分 */
			data[0] = (buf[1] >> 4) + 0x30;
			OLED_SSD1306_println(data);
			data[0] = (buf[1] & 0x0F) + 0x30;
			OLED_SSD1306_println(data);
			OLED_SSD1306_println(":");
			/* 秒 */
			data[0] = (buf[0] >> 4) + 0x30;
			OLED_SSD1306_println(data);
			data[0] = (buf[0] & 0x0F) + 0x30;
			OLED_SSD1306_println(data);
		}
	}
    /* End user code. Do not edit comment generated here */
	return 0;
}

/***********************************************************************************************************************
* Function Name: R_MAIN_UserInit
* Description  : This function adds user code before implementing main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_MAIN_UserInit(void)
{
    /* Start user code. Do not edit comment generated here */
    EI();
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */

static void RTC_DS1307_init(void)
{
	uint8_t buf[8];
	
	buf[0] = 0x00;  /* レジスタアドレス */
	buf[1] = 0x00;	/* 00h：秒 */
	buf[2] = 0x05;	/* 01h：分 */
	buf[3] = 0x01;	/* 02h：時 */
	buf[4] = 0x00;	/* 03h：曜日 */
	buf[5] = 0x06;  /* 04h：日 */
	buf[6] = 0x08;	/* 05h：月 */
	buf[7] = 0x21;	/* 06h：年 */
	
	i2c_flag = 0;
	R_IICA0_Master_Send(I2C_RTC_ADDR, buf, 8, 1);		/* I2C送信実行 */
	while (i2c_flag == 0) ;								/* 送信完了待ち */
	R_IICA0_StopCondition();							/* I2C通信終了 */
	while (SPD0 == 0) ;									/* ストップ・コンディション検出待ち */
	
	return;
}

static void RTC_DS1307_read(uint8_t *date)
{
	uint8_t buf[7];
	
	buf[0] = 0x00;  /* レジスタアドレス */
	
	i2c_flag = 0;
	R_IICA0_Master_Send(I2C_RTC_ADDR, buf, 1, 1);		/* I2C送信実行 */
	while (i2c_flag == 0) ;								/* 送信完了待ち */
	R_IICA0_StopCondition();							/* I2C通信終了 */
	while (SPD0 == 0) ;									/* ストップ・コンディション検出待ち */	
	
	i2c_flag = 0;
	R_IICA0_Master_Receive(I2C_RTC_ADDR, date, 7 , 1);	/* I2C受信実行 */
	while (i2c_flag == 0) ;								/* 送信完了待ち */
	R_IICA0_StopCondition();							/* I2C通信終了 */
	while (SPD0 == 0) ;									/* ストップ・コンディション検出待ち */
	
	return;
}

static void OLED_SSD1306_init(void)
{
	uint8_t buf[29];
	
	buf[0] = SSD1306_CONTROL_CMD_STREAM;				/* コントロールバイト */
	
	/* Display off */
	buf[1] = SSD1306_DISPLAY_OFF;
	
	/* Set MUX Ratio A8h, 3Fh*/
	buf[2] = SSD1306_SET_MULTIPLEX_RATIO;
	buf[3] =0x3F;
	
	/* Set Display Offset D3h, 00h */
	buf[4] = SSD1306_SET_DISPLAY_OFFSET;
	buf[5] = 0x00;
	
	/* Set Display Start Line 40h */
	buf[6] = SSD1306_SET_DISPLAY_START_LINE;
	
	/* Set Segment re-map A0h/A1h */
	buf[7] = SSD1306_SET_SEGMENT_REMAP_LOW;
	
	/* Set COM Output Scan Direction C0h/C8h */
	buf[8] = SSD1306_SET_COM_SCAN_INC;
	
	/* Set COM Pins hardware configuration DAh, 02*/
	buf[9] = SSD1306_SET_COM_PIN_MAP;
	buf[10] = 0x12;
	
	/* Set Contrast Control 81h, 7Fh */
	buf[11] = SSD1306_SET_CONTRAST;
	buf[12] = 0x7F;
	
	/* Disable Entire Display On A4h */
	buf[13] = SSD1306_DISPLAY_ALL_ON_RESUME;
	
	/* Set Normal Display A6h */
	buf[14] = SSD1306_NORMAL_DISPLAY;
	
	/* Set Osc Frequency D5h, 80h */
	buf[15] = SSD1306_SET_DISPLAY_CLK_DIV;
	buf[16] = 0x80;	
	
	buf[17] = SSD1306_SET_MEMORY_ADDR_MODE;
	buf[18] = 0x10;
	
	buf[19] = SSD1306_SET_COLUMN_RANGE;
	buf[20] = 0x00;
	buf[21] = 0x7F;
	
	buf[22] = SSD1306_SET_PAGE_RANGE;
	buf[23] = 0x00;
	buf[24] = 0x07;
	
	buf[25] = SSD1306_DEACTIVATE_SCROLL;
	
	/* Enable charge pump regulator 8Dh, 14h */
	buf[26] = SSD1306_SET_CHARGE_PUMP;
	buf[27] = 0x14;
	
	/* Display On AFh */
	buf[28] = SSD1306_DISPLAY_ON;
	
	i2c_flag = 0;
	R_IICA0_Master_Send(I2C_LED_ADDR, buf, 29, 1);		/* I2C送信実行 */
	while (i2c_flag == 0) ;								/* 送信完了待ち */
	R_IICA0_StopCondition();							/* I2C通信終了 */
	while (SPD0 == 0) ;									/* ストップ・コンディション検出待ち */
	
	return;
}

static void OLED_SSD1306_clear(void)
{
	uint8_t i,j;
	uint8_t buf[9];
	
	for(i = 0; i < 8; i++) {
		buf[0] = SSD1306_CONTROL_CMD_STREAM;			/* コントロールバイト */
		buf[1] = SSD1306_SET_PAGE_START_ADDRESS | i;	/* set page start address(B0～B7) */
		buf[2] = SSD1306_SET_COLUMN_RANGE;				/* set Column Address */
		buf[3] = 0x00;									/* Column Start Address(0-127) */
		buf[4] = 0x7F;									/* Column Stop Address(0-127) */
		
		i2c_flag = 0;
		R_IICA0_Master_Send(I2C_LED_ADDR, buf, 5, 1);	/* I2C送信実行 */
		while (i2c_flag == 0) ;							/* 送信完了待ち */
		R_IICA0_StopCondition();						/* I2C通信終了 */
		while (SPD0 == 0) ;								/* ストップ・コンディション検出待ち */
		
		buf[0] = SSD1306_CONTROL_DATA_STREAM;			/*	コントロールバイト */
		for(j = 0; j < 8; j++) {
			buf[1 + j] = 0x00;
		}
		for(j = 0; j < 16; j++) {
			i2c_flag = 0;
			R_IICA0_Master_Send(I2C_LED_ADDR, buf, 9, 1);	/* I2C送信実行 */
			while (i2c_flag == 0) ;						/* 送信完了待ち */
			R_IICA0_StopCondition();					/* I2C通信終了 */
			while (SPD0 == 0) ;							/* ストップ・コンディション検出待ち */
		}
	}
	g_x = 0;
	g_y = 0;
	
	return;
}

static char* OLED_SSD1306_writeChar(char *data)
{
	uint8_t buf[9];
	
	if (*data == 0x0a) {
		OLED_SSD1306_newLine();
		data += 1;
	} else if ((*data == 0x5c) && (*(data + 1) == 0x6e)) {
		OLED_SSD1306_newLine();
		data += 2;
	} else if ((g_y < 8) && (g_x < 16)) {
		/* コマンド */
		buf[0] = SSD1306_CONTROL_CMD_STREAM;			/* コントロールバイト */
		buf[1] = SSD1306_SET_PAGE_START_ADDRESS | g_y;	/* ページ指定, 垂直位置 */
		buf[2] = SSD1306_SET_COLUMN_RANGE;				/* サブアドレス */
		buf[3] = g_x << 3;								/* 水平位置 */
		buf[4] = (g_x << 3) + 7;						/* 折り返し */
		i2c_flag = 0;
		R_IICA0_Master_Send(I2C_LED_ADDR, buf, 5, 1);	/* I2C送信実行 */
		while (i2c_flag == 0) ;							/* 送信完了待ち */
		R_IICA0_StopCondition();						/* I2C通信終了 */
		while (SPD0 == 0) ;								/* ストップ・コンディション検出待ち */
		
		/* データ */
		buf[0] = SSD1306_CONTROL_DATA_STREAM;			/* コントロールバイト */
		data = getFontData(&buf[1], data, true);
		
		i2c_flag = 0;
		R_IICA0_Master_Send(I2C_LED_ADDR, buf, 9, 1);	/* I2C送信実行 */
		while (i2c_flag == 0) ;							/* 送信完了待ち */
		R_IICA0_StopCondition();						/* I2C通信終了 */
		while (SPD0 == 0) ;								/* ストップ・コンディション検出待ち */
		g_x++;
	} else {
		;
	}
	
	return data;
}

static void OLED_SSD1306_newLine(void)
{
	g_x = 0;
	if(g_y < 8) {
		g_y++;
	} else {
		g_y = 0;
	}
	
	return;
}

static void OLED_SSD1306_println(char *data)
{	
	do {
		data = OLED_SSD1306_writeChar(data);
	} while(*data != '\0');
	
	return;
}

/* End user code. Do not edit comment generated here */
